'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extend = require('./extend');

var _extend2 = _interopRequireDefault(_extend);

var _splice = require('./splice');

var _splice2 = _interopRequireDefault(_splice);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  $set: function $set(obj, val) {
    return val;
  },

  $merge: function $merge(obj, val) {
    return (0, _extend2.default)(obj, val);
  },

  $apply: function $apply(obj, val) {
    return val(obj);
  },

  $splice: function $splice(obj, val) {
    for (var i = 0, l = val.length; i < l; ++i) {
      (0, _splice2.default)(obj, val[i]);
    }return obj;
  },

  $push: function $push(obj, val) {
    return (0, _splice2.default)(obj, [obj.length, 0].concat(val));
  },

  $pop: function $pop(obj) {
    return (0, _splice2.default)(obj, [-1, 1]);
  },

  $unshift: function $unshift(obj, val) {
    return (0, _splice2.default)(obj, [0, 0].concat(val));
  },

  $shift: function $shift(obj) {
    return (0, _splice2.default)(obj, [0, 1]);
  }
};
