'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isArray = require('./is-array');

var _isArray2 = _interopRequireDefault(_isArray);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getQueryCost = function getQueryCost(query) {
  var limit = arguments.length <= 1 || arguments[1] === undefined ? Infinity : arguments[1];
  var cost = arguments.length <= 2 || arguments[2] === undefined ? 0 : arguments[2];
  var total = arguments.length <= 3 || arguments[3] === undefined ? 0 : arguments[3];

  var i = 0;
  var l = query.length;
  while (i < l && total + cost + i <= limit && !(0, _isArray2.default)(query[i])) {
    ++i;
  }if (total + (cost += i) > limit || i === l) return total + cost;

  var pivot = query[i];
  var rest = query.slice(i + 1);
  for (var _i = 0, _l = pivot.length; _i < _l; ++_i) {
    total = getQueryCost([].concat(pivot[_i], rest), limit, cost, total);
    if (total > limit) return total;
  }

  return total;
};

exports.default = getQueryCost;
