'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toKey = require('./to-key');

var _toKey2 = _interopRequireDefault(_toKey);

var _getRaw = require('./get-raw');

var _getRaw2 = _interopRequireDefault(_getRaw);

var _isObject = require('./is-object');

var _isObject2 = _interopRequireDefault(_isObject);

var _isArray = require('./is-array');

var _isArray2 = _interopRequireDefault(_isArray);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var checkRefs = function checkRefs(raw, a, b, visited) {

  // Values aren't refs.
  if (!(0, _isObject2.default)(raw)) return true;

  // Look for refs in an array.
  if ((0, _isArray2.default)(raw)) {
    for (var i = 0, l = raw.length; i < l; ++i) {
      if (!checkRefs(raw[i], a, b, visited)) return false;
    }

    return true;
  }

  // Found a ref.
  if (raw.$ref) return isEqual(raw.$ref, a, b, visited);

  // Look for refs in an object.
  for (var key in raw) {
    if (!checkRefs(raw[key], a, b, visited)) return false;
  }return true;
};

var isEqual = function isEqual(path, a, b) {
  var visited = arguments.length <= 3 || arguments[3] === undefined ? {} : arguments[3];

  var key = (0, _toKey2.default)(path);
  if (visited[key]) return true;

  var raw = (0, _getRaw2.default)(a, path);
  if (raw !== (0, _getRaw2.default)(b, path)) return false;

  visited[key] = true;
  return checkRefs(raw, a, b, visited);
};

exports.default = isEqual;
