'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _deltaDirectives = require('./delta-directives');

var _deltaDirectives2 = _interopRequireDefault(_deltaDirectives);

var _flatten = require('./flatten');

var _flatten2 = _interopRequireDefault(_flatten);

var _isArray = require('./is-array');

var _isArray2 = _interopRequireDefault(_isArray);

var _isObject = require('./is-object');

var _isObject2 = _interopRequireDefault(_isObject);

var _resolvePath = require('./resolve-path');

var _resolvePath2 = _interopRequireDefault(_resolvePath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var resolveDelta = function resolveDelta(cache, delta) {
  var path = arguments.length <= 2 || arguments[2] === undefined ? [] : arguments[2];

  var deltas = [];

  if (!(0, _isObject2.default)(delta)) return deltas;

  if ((0, _isArray2.default)(delta)) {
    delta = (0, _flatten2.default)(delta);

    for (var i = 0, l = delta.length; i < l; ++i) {
      deltas.push.apply(deltas, resolveDelta(cache, delta[i]));
    }

    return deltas;
  }

  for (var key in delta) {
    var directive = _deltaDirectives2.default[key];
    if (directive) {
      for (var _i = path.length - 1; _i >= 0; --_i) {
        delta = _defineProperty({}, path[_i], delta);
      }return [delta];
    }
  }

  for (var _key in delta) {
    deltas.push.apply(deltas, resolveDelta(cache, delta[_key], (0, _resolvePath2.default)(cache, path).concat(_key)));
  }

  return deltas;
};

exports.default = resolveDelta;
