'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get = require('./get');

var _get2 = _interopRequireDefault(_get);

var _isArray = require('./is-array');

var _isArray2 = _interopRequireDefault(_isArray);

var _isObject = require('./is-object');

var _isObject2 = _interopRequireDefault(_isObject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var resolveRefs = function resolveRefs(cache, obj, visited, key) {
  var setVisited = function setVisited(val) {
    return key ? visited[key] = val : val;
  };

  if (!(0, _isObject2.default)(obj)) return setVisited(obj);

  if ((0, _isArray2.default)(obj)) {
    var _val = setVisited([]);
    for (var i = 0, l = obj.length; i < l; ++i) {
      _val.push(resolveRefs(cache, obj[i], visited));
    }
    return _val;
  }

  var $ref = obj.$ref;

  if ($ref) return setVisited((0, _get2.default)(cache, $ref, visited));

  var val = setVisited({});
  for (var _key in obj) {
    val[_key] = resolveRefs(cache, obj[_key], visited);
  }return val;
};

exports.default = resolveRefs;
