'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isArray = require('./is-array');

var _isArray2 = _interopRequireDefault(_isArray);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

exports.default = function (obj, _ref) {
  var _ref2 = _toArray(_ref);

  var _ref2$ = _ref2[0];
  var start = _ref2$ === undefined ? 0 : _ref2$;
  var _ref2$2 = _ref2[1];
  var deleteCount = _ref2$2 === undefined ? 0 : _ref2$2;

  var items = _ref2.slice(2);

  if ((0, _isArray2.default)(obj)) {
    obj.splice.apply(obj, [start, deleteCount].concat(_toConsumableArray(items)));
  } else {
    if (obj.length == null) obj.length = 0;
    if (start < 0) start = Math.max(0, obj.length + start);
    var offset = items.length - deleteCount;

    // Delete leading holes.
    for (var i = 0; i < deleteCount; ++i) {
      delete obj[start + i];
    } // Shift.
    for (var _i = start + items.length; _i < obj.length; ++_i) {
      obj[_i] = obj[_i - offset];
    }

    // Replace.
    for (var _i2 = 0, l = items.length; _i2 < l; ++_i2) {
      obj[start + _i2] = items[_i2];
    } // Delete trailing holes.
    for (var _i3 = -1; _i3 >= offset; --_i3) {
      delete obj[obj.length + _i3];
    }obj.length += offset;
  }

  return obj;
};
