'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _isPromise = require('./is-promise');

var _isPromise2 = _interopRequireDefault(_isPromise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SyncPromise = function () {
  function SyncPromise(callback) {
    var _this = this;

    _classCallCheck(this, SyncPromise);

    var completed = false;

    var complete = function complete(state, value) {
      completed = true;
      _this.state = state;
      _this.value = value;
      var callbacks = _this.callbacks[state];
      for (var i = 0, l = callbacks.length; i < l; ++i) {
        callbacks[i](value);
      }
    };

    var resolve = function resolve(value) {
      if (completed) return;
      if ((0, _isPromise2.default)(value)) return value.then(resolve).catch(reject);
      complete('fulfilled', value);
    };

    var reject = function reject(reason) {
      if (completed) return;
      if ((0, _isPromise2.default)(reason)) return reason.then(reject).catch(reject);
      complete('rejected', reason);
    };

    this.state = 'pending';
    this.callbacks = { fulfilled: [], rejected: [] };
    try {
      callback(resolve, reject);
    } catch (er) {
      reject(er);
    }
  }

  _createClass(SyncPromise, [{
    key: 'then',
    value: function then(onFulfilled, onRejected) {
      var _this2 = this;

      return new SyncPromise(function (resolve, reject) {
        var _callbacks = _this2.callbacks;
        var fulfilled = _callbacks.fulfilled;
        var rejected = _callbacks.rejected;
        var state = _this2.state;
        var value = _this2.value;


        var runFulfilled = onFulfilled ? function (value) {
          return resolve(onFulfilled(value));
        } : resolve;

        var runRejected = onRejected ? function (value) {
          return resolve(onRejected(value));
        } : reject;

        if (state === 'fulfilled') return runFulfilled(value);
        if (state === 'rejected') return runRejected(value);
        fulfilled.push(runFulfilled);
        rejected.push(runRejected);
      });
    }
  }, {
    key: 'catch',
    value: function _catch(onRejected) {
      return this.then(null, onRejected);
    }
  }]);

  return SyncPromise;
}();

SyncPromise.resolve = function (value) {
  return new SyncPromise(function (resolve) {
    return resolve(value);
  });
};

SyncPromise.reject = function (reason) {
  return new SyncPromise(function (_, reject) {
    return reject(reason);
  });
};

SyncPromise.all = function (promises) {
  return new SyncPromise(function (resolve, reject) {
    var done = 0;
    var values = [];

    var _loop = function _loop(i, l) {
      promises[i].then(function (value) {
        values[i] = value;
        if (++done === l) resolve(values);
      }).catch(reject);
    };

    for (var i = 0, l = promises.length; i < l; ++i) {
      _loop(i, l);
    }
  });
};

SyncPromise.race = function (promises) {
  return new SyncPromise(function (resolve, reject) {
    for (var i = 0, l = promises.length; i < l; ++i) {
      promises[i].then(resolve).catch(reject);
    }
  });
};

exports.default = SyncPromise;
