'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _clone = require('./clone');

var _clone2 = _interopRequireDefault(_clone);

var _isObject = require('./is-object');

var _isObject2 = _interopRequireDefault(_isObject);

var _deltaDirectives = require('./delta-directives');

var _deltaDirectives2 = _interopRequireDefault(_deltaDirectives);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var update = function update(obj, delta) {
  if (obj == null) obj = {};

  var next = (0, _clone2.default)(obj);

  if ((0, _isObject2.default)(delta)) {
    for (var key in _deltaDirectives2.default) {
      if (key in delta) return _deltaDirectives2.default[key](next, delta[key]);
    }
  }

  for (var _key in delta) {
    next[_key] = update(next[_key], delta[_key]);
  }return next;
};

exports.default = update;
